module AliceIWBTGNeedle

using ..Ahorn, Maple

@mapdef Entity "Needle Helper/IWBTGNeedle" IWBTGNeedle(x::Integer, y::Integer, direction::String="Up", directory::String="objects/NeedleHelper")

const needledirections = String[
    "Up",
    "Down",
    "Left",
    "Right"
]

needledirectionspr = Dict{String, String}(
    "Up" => "/NeedleUp/needle00",
    "Down" => "/NeedleDown/needle00",
    "Left" => "/NeedleLeft/needle00",
    "Right" => "/NeedleRight/needle00",
)

const placements = Ahorn.PlacementDict(
    "IWBTG Needle (unholy, Needle Helper)" => Ahorn.EntityPlacement(
        IWBTGNeedle
    )
)

Ahorn.editingOptions(entity::IWBTGNeedle) = Dict{String, Any}(
    "direction" => needledirections
)

function Ahorn.selection(entity::IWBTGNeedle)
    x, y = Ahorn.position(entity)
    return Ahorn.Rectangle(x-8, y-8, 16, 16)
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::IWBTGNeedle, room::Maple.Room)
    str = get(entity.data, "directory", "objects/NeedleHelper")
    dir = get(entity.data, "direction", "Up")
    sprite = str * needledirectionspr[dir]
    Ahorn.drawSprite(ctx, sprite, 0, 0)
end

end
